<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.humantask.ui.HumanTaskOperationsClient" %>
<%@ page import="org.apache.axis2.AxisFault" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.wso2.carbon.utils.xml.XMLPrettyPrinter" %>
<%@ page import="java.io.ByteArrayInputStream" %>
<%@ page import="java.io.StringReader" %>
<%@ page import="java.io.StringWriter" %>
<%@ page import="org.wso2.carbon.humantask.ui.prettyxml.PrettyXML" %>
<fmt:bundle basename="org.wso2.carbon.humantask.ui.i18n.Resources">
<%
    Log log = LogFactory.getLog("task.dispatch.ajaxprocessor");

//    request.setCharacterEncoding("UTF-8");
    // Set content to xml
//    response.setContentType("application/json; charset=UTF-8");
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    HumanTaskOperationsClient client;
    OMElement mockitMessage = null;

    String taskID = request.getParameter("taskId").trim();
    String type = request.getParameter("type").trim();

    if (taskID == null || type == null) {
        String errMsg = "Task ID or request type is null";
        log.error(errMsg);
        pageContext.setAttribute("error", errMsg);
        %>
            <p id="ERRORDIALOG"><fmt:message key="taskid.null"/><br/></p>
        <%
        return;
    }

    try {
        client = new HumanTaskOperationsClient(configContext, backendServerURL, cookie);
    } catch (AxisFault e) {
        String errMsg = "Error occurred during HumanTaskOperationsClient creation.";
        log.error(errMsg, e);
        pageContext.setAttribute("error", errMsg);
        %>
            <p id="ERRORDIALOG"><fmt:message key="error.create.operation.client"/><br/></p>
        <%
        return;
    }

    try {
        if (type.equals("REQUEST")) {
            mockitMessage = client.getRequestMessage(taskID);
        } else if (type.equals("RESPONSE")) {
            mockitMessage = client.getResponseMessage(taskID);
        } else {
            %>
                <p id="ERRORDIALOG"><fmt:message key="error.invalid.argument.type"/><br/></p>
            <%
        }
        if (mockitMessage == null) {
            %>
                <p id="ERRORDIALOG"><fmt:message key="error.load.message"/><br/></p>
            <%
            return;
        }
        XMLPrettyPrinter xmlPP = new XMLPrettyPrinter(new ByteArrayInputStream(mockitMessage.toString().getBytes()));
        String prittyPrintedStr = xmlPP.xmlFormat();
        StringReader sr = new StringReader(prittyPrintedStr);
		StringWriter sw = new StringWriter();
        PrettyXML.init();
		PrettyXML.writeFancily(sr, sw);
		sr.close();
        prittyPrintedStr = sw.toString();
        %>
            <div id="INFODIALOG"><pre><%=prittyPrintedStr%></pre></div>
        <%
    } catch (Exception e) {
        String errMsg = "Error occurred while loading request message";
        log.error(errMsg, e);
        pageContext.setAttribute("error", errMsg);
        %>
            <p id="ERRORDIALOG"><fmt:message key="error.load.request"/><br/><%=e.toString()%></p>
        <%
    }

%>

</fmt:bundle>
